--- daemonlogger.c.orig	2008-11-24 14:56:48.000000000 -0500
+++ daemonlogger.c	2010-05-27 23:03:06.000000000 -0400
@@ -569,6 +595,66 @@
     return 0;
 }
 
+static int count_of_files_in_dir()
+{
+    DIR *dirp;
+    struct dirent *dp;
+    struct stat sb;
+    char fpath[STDBUF+1];
+    int count = 0;
+    
+    memset(fpath, 0, STDBUF+1);
+    if(logpath != NULL)
+    {
+        dirp = opendir(logpath);        
+    }
+    else
+        dirp = opendir(".");
+    
+    if(dirp == NULL)
+    {
+        msg("opendir failed\n");
+        return 0;
+    }
+    
+    while((dp = readdir(dirp)) != NULL)
+    {
+        snprintf(fpath, STDBUF, "%s/%s", logpath?logpath:".", dp->d_name);
+        if(stat(fpath, &sb) != 0)
+            msg("stat failed for \"%s\": %s\n", fpath, strerror(errno));
+        
+        if((sb.st_mode & S_IFMT) == S_IFREG)
+        {
+            count++;
+        }
+    }
+    return count;
+}
+
+static int adjust_file_count()
+{
+    int existing;
+    int overage;
+    
+    if (maxfiles == 0 || ringbuffer == 0 || prune_flag == PRUNE_OLDEST_IN_RUN)
+        return SUCCESS;
+    
+    existing = count_of_files_in_dir();
+    
+    if (existing <= maxfiles) {
+        filecount = maxfiles - existing;
+    } else {
+        filecount = 0;
+        overage = existing - maxfiles;
+        while (overage > 0) {
+            prune_oldest_file_in_dir();
+            overage--;
+        }
+    }
+
+    return SUCCESS;
+}
+
 static int open_log_file()
 {
     struct file_entry *fe;
@@ -1432,6 +1524,8 @@
         }
     }
     
+    adjust_file_count();
+    
     if(daemon_mode) 
     {
         if(!is_valid_path(pidpath))
